SystemOrganization addCategory: #'Magritte-Json'!

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:53'!
defaultJsonName
	"Answer the default JSON element name."

	^ self accessor selector seasideString capitalized! !

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:53'!
jsonName
	"Answer the JSON element name."

	^ self propertyAt: #jsonName ifAbsent: [ self defaultJsonName ]! !

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:52'!
jsonName: aString
	self propertyAt: #jsonName put: aString! !

MAWriter subclass: #MJJsonWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MJJsonWriter methodsFor: 'private' stamp: 'pmm 8/31/2009 09:29'!
defaultWriteStream
	^ WriteStream on: String new! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'pmm 8/31/2009 20:49'!
visitContainer: aDescription
	| first |
	first := true.
	stream nextPut: ${.
	aDescription do: [ :each |
		each isJsonSerialized ifTrue: [
			first
				ifTrue: [ first := false ]
				ifFalse: [ stream nextPut: $, ].
			self writeElementKeyOf: each.
			stream nextPut: $:.
			each jsonWriter
				write: (self object readUsing: each)
				description: each to: stream ] ].
	stream nextPut: $}! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'pmm 8/31/2009 20:53'!
visitDateAndTimeDescription: aDescription
	self stream print: self object! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'pmm 8/31/2009 20:42'!
visitElementDescription: aDescription
	self object javascriptOn: self stream! !

!MJJsonWriter methodsFor: 'private' stamp: 'pmm 8/31/2009 20:48'!
writeElementKeyOf: aDescription
	JSJsonStream
		encodeKey: aDescription jsonName
		on: self stream.! !

MAReader subclass: #MJJsonReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MADescription class methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:34'!
defaultJsonReader
	^ MJJsonReader! !

!MADescription class methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:35'!
defaultJsonWriter
	^ MJJsonWriter! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 20:36'!
defaultJsonSerialized
	^self isVisible! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:59'!
isJsonSerialized
	"Answer whether the described object should be serialized to JSON."

	^ self propertyAt: #jsonSerialized ifAbsent: [ self defaultJsonSerialized ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:36'!
jsonReader
	"Answer a Visitor that can be used to parse the model described by the receiver from a JSON string."

	^ self propertyAt: #jsonReader ifAbsent: [ self class defaultJsonReader ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:36'!
jsonReader: aClass
	self propertyAt: #jsonReader put: aClass! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:59'!
jsonSerialized: aBoolean

	^ self propertyAt: #jsonSerialized put: aBoolean! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:37'!
jsonWriter
	"Answer a Visitor that can be used to convert the model described by the receiver to a JSON string."

	^ self propertyAt: #jsonWriter ifAbsent: [ self class defaultJsonWriter ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:37'!
jsonWriter: aClass
	"Answer a Visitor that can be used to convert the model described by the receiver to a JSON string."

	self propertyAt: #jsonWriter put: aClass! !
